















/*----------------------------------------------------------------------- 
 * 
 * File Name: PROGNAMETest.c
 * 
 * Author: Finn, L. S. 
 * 
 * Revision: $Id: DestroyVectorSequenceTest.m4,v 1.2 2000/02/26 21:18:12 jolien Exp $
 * 
 *----------------------------------------------------------------------- 
 * 
 * NAME 
 *   main()
 *
 * SYNOPSIS 
 * 
 * DESCRIPTION 
 *   Test suite for VectorSequence factories
 * 
 * DIAGNOSTICS
 * 
 * CALLS
 *   I4CreateVectorSequence
 *   I4DestroyVectorSequence
 * 
 * NOTES
 *   Automatically generated from dvst.tmpl by m4
 *
 * 
 *-----------------------------------------------------------------------
 */

#ifndef _STDIO_H
#include <stdio.h>
#ifndef _STDIO_H
#define _STDIO_H
#endif
#endif

#ifndef _STRING_H
#include <string.h>
#ifndef _STRING_H
#define _STRING_H
#endif
#endif

#ifndef _LALDATATYPES_H
#include "LALDatatypes.h"
#ifndef _LALDATATYPES_H
#define _LALDATATYPES_H
#endif
#endif

#ifndef _SEQFACTORIES_H
#include "SeqFactories.h"
#ifndef _SEQFACTORIES_H
#define _SEQFACTORIES_H
#endif
#endif

NRCSID (MAIN, "$Id: DestroyVectorSequenceTest.m4,v 1.2 2000/02/26 21:18:12 jolien Exp $");

int debuglevel = 2;

typedef INT4VectorSequence stype;
typedef INT4 dtype;

int main()
{

  static Status status;		/*  */
  stype *seq = NULL;		/*  */
  dtype *data = NULL;
  int rcode = 0;

  /* Announcements */
  printf ( "Testing %s\n" , "I4DestroyVectorSequence" );

  /* Test error returns */

  /* NULL seq */

  rcode++;	
  I4DestroyVectorSequence ( &status, NULL );
  if (status.statusCode != DESTROYVECSEQ_EVPTR)   
    printf("FAIL seq == NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYSEQ_MSGEVPTR) != 0)   
    printf("FAIL seq == NULL: statusDescription mismatch\n");
  else 
    {
      rcode--;
      printf("PASS seq == NULL\n");
    }

  /* NULL *seq */


  rcode++;
  seq = NULL;
  I4DestroyVectorSequence ( &status, &seq );
  if (status.statusCode != DESTROYVECSEQ_EUPTR)   
    printf("FAIL return struct ptr is NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYVECSEQ_MSGEUPTR) != 0)   
    printf("FAIL return struct ptr is NULL: statusDescription mismatch\n");
  else 
    {
      rcode--;
      printf("PASS return struct ptr is NULL\n");
    }

  /* seq->data == NULL */

  {
    CreateVectorSequenceIn in;
    in.length = 10;
    in.vectorLength = 20;
    (void) I4CreateVectorSequence ( &status, &seq, &in );
  }

  rcode++;
  data = seq->data;		/* save pointer to data */
  seq->data = NULL;		/* make mal-formed seq */
  I4DestroyVectorSequence ( &status, &seq );
  if (status.statusCode != DESTROYVECSEQ_EDPTR)   
    printf("FAIL seq->data == NULL: wrong status code\n");
  else if (strcmp(status.statusDescription,DESTROYVECSEQ_MSGEDPTR) != 0)   
    printf("FAIL seq->data == NULL: statusDescription mismatch\n");
  else if (seq == NULL)
    printf("FAIL seq->data == NULL: seq changed\n");
  else 
    { 
      rcode--;
      printf("PASS seq->data == NULL\n");
    }

  /* Test destruction */  

  rcode++;
  seq->data = data;		/* we're correct again */
  I4DestroyVectorSequence ( &status, &seq );
  if ( seq != NULL )
    printf("FAIL Destruction: seq != NULL\n");
  else if (status.statusCode != 0)
    printf("FAIL Destruction: normal exit with non-zero statusCode");
  else
    {
      rcode--;
      printf("PASS Destruction\n");
    }

  /* We should have correctly set the status Id field: */

  printf ( "Test results for %s\n", status.Id );
  printf ( "Tested by %s\n", MAIN);

  exit(rcode==0?0:-1);
}
